// Created on: 1993-03-03
// Created by: Philippe DAUTRY
// Copyright (c) 1993-1999 Matra Datavision
// Copyright (c) 1999-2014 OPEN CASCADE SAS
//
// This file is part of Open CASCADE Technology software library.
//
// This library is free software; you can redistribute it and/or modify it under
// the terms of the GNU Lesser General Public License version 2.1 as published
// by the Free Software Foundation, with special exception defined in the file
// OCCT_LGPL_EXCEPTION.txt. Consult the file LICENSE_LGPL_21.txt included in OCCT
// distribution for complete text of the license and disclaimer of any warranty.
//
// Alternatively, this file may be used under the terms of Open CASCADE
// commercial license or contractual agreement.

#include <PGeom2d_Circle.ixx>

//=======================================================================
//function : PGeom2d_Circle
//purpose  : 
//=======================================================================

PGeom2d_Circle::PGeom2d_Circle()
{}


//=======================================================================
//function : PGeom2d_Circle
//purpose  : 
//=======================================================================

PGeom2d_Circle::PGeom2d_Circle
  (const gp_Ax22d& aPosition,
   const Standard_Real aRadius) :
  PGeom2d_Conic(aPosition),
  radius(aRadius)
{}


//=======================================================================
//function : Radius
//purpose  : 
//=======================================================================

void  PGeom2d_Circle::Radius(const Standard_Real aRadius)
{ radius = aRadius; }


//=======================================================================
//function : Radius
//purpose  : 
//=======================================================================

Standard_Real  PGeom2d_Circle::Radius() const 
{ return radius; }
